Arbor 3: FSM & BT Graph Editor 3.5.0

- Main Page
- Packages
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Public Attributes | Protected Member Functions | Properties | List of all members
State Class Reference

ステートを表すクラス More...

Inheritance diagram for State:

## Public Member Functions
| State (ArborFSMInternal stateMachine, int nodeID, bool resident)
| Stateのコンストラクタ More...
void | AddBehaviour (StateBehaviour behaviour)
| StateBehaviourを追加。 More...
StateBehaviour | AddBehaviour (System.Type type)
| StateBehaviourを追加。 More...
T | AddBehaviour< T > ()
| StateBehaviourを追加。 More...
void | InsertBehaviour (int index, StateBehaviour behaviour)
| StateBehaviourを挿入。 More...
StateBehaviour | InsertBehaviour (int index, System.Type type)
| StateBehaviourを挿入。 More...
T | InsertBehaviour< T > (int index)
| StateBehaviourを追加。 More...
StateBehaviour | GetBehaviourFromIndex (int index)
| StateBehaviourをindexから取得。 More...
Object | GetBehaviourObjectFromIndex (int index)
| StateBehaviourのObjectをindexから取得。 More...
StateBehaviour | GetBehaviour (System.Type type)
| StateBehaviourを取得。 More...
T | GetBehaviour< T > ()
| StateBehaviourを取得。 More...
StateBehaviour[] | GetBehaviours (System.Type type)
| StateBehaviourを取得。 More...
T[] | GetBehaviours< T > ()
| StateBehaviourを取得。 More...
bool | Contains (StateBehaviour behaviour)
| StateBehaviourが含まれているかどうか。 More...
int | IndexOfBehaviour (Object behaviourObj)
| StateBehaviourのインデックスを返す。 More...
void | RemoveBehaviour (Object behaviourObj)
| StateBehaviourを削除する。インスタンスは削除されないため、StateBehaviour.Destroyを使用すること。 More...
void | SwapBehaviour (int fromIndex, int toIndex)
| StateBehaviourの順番を入れ替える。 More...
void | MoveBehaviour (int fromIndex, State toState, int toIndex)
| StateBehaviourの順番を移動する。 More...
void | SetBehaviour (int index, StateBehaviour behaviour)
| StateBehaviourを設定する。 More...
override bool | IsContainsBehaviour (NodeBehaviour behaviour)
| NodeBehaviourを含んでいるかをチェックする。 More...
void | DisconnectState (int stateID)
| 内部処理用。 More...
void | DestroyBehaviour (Object behaviourObj)
| StateBehaviourを破棄する。 More...
void | DestroyBehaviours ()
| 内部処理用。 More...
void | UpdateBehaviours ()
| 内部処理用。 More...
void | LateUpdateBehaviours ()
| 内部処理用。 More...
void | SendTrigger (string message)
| トリガーメッセージを送信する。StateBehaviour.OnStateTriggerが呼び出される。 More...
override string | GetName ()
| ノードの名前を取得 More...
Public Member Functions inherited from Node
| Node (NodeGraph nodeGraph, int nodeID)
| Nodeのコンストラクタ More...
virtual bool | IsDeletable ()
| 削除できるかどうかを返す。 More...
override string | ToString ()
| ノードを文字列に変換（デバッグ用）。 More...

## Public Attributes
string | name = "New State"
| ステートの名前。 More...
Public Attributes inherited from Node
Rect | position
| Arbor Editor上での位置。 More...
bool | showComment
| コメントを表示するかどうか More...
string | nodeComment
| コメント More...

## Protected Member Functions
override void | OnGraphChanged ()
| Nodeが所属するNodeGraphが変わった際に呼ばれる。 More...

## Properties
ArborFSMInternal | stateMachine`[get]`
| FSMを取得。 More...
StateBehaviour[] | behaviours`[get]`
| 非推奨。behaviourCountとGetBehaviourFromIndexを使用して下さい。 More...
int | behaviourCount`[get]`
| Behaviourの数を取得。 More...
int | stateID`[get]`
| ステートIDを取得。 More...
bool | resident`[get]`
| 常駐するStateかどうかを取得。 More...
bool | breakPoint`[get, set]`
| Break point. More...
uint | transitionCount`[get, set]`
| 遷移回数。 More...
Properties inherited from Node
NodeGraph | nodeGraph`[get]`
| NodeGraphを取得。 More...
int | nodeID`[get]`
| ノードIDを取得。 More...

## Detailed Description

ステートを表すクラス

## Constructor & Destructor Documentation

State | ( | ArborFSMInternal | stateMachine,
|  | int | nodeID,
|  | bool | resident
| ) |  |

Stateのコンストラクタ

Parameters

  stateMachine | このノードを持つステートマシン
  nodeID | ノードID
  resident | 常駐ステート

ステートの生成はArborFSMInternal.CreateState(bool)を使用してください。

## Member Function Documentation

void AddBehaviour | ( | StateBehaviour | behaviour | ) |

StateBehaviourを追加。

Parameters

  behaviour | 追加するStateBehaviour

StateBehaviour AddBehaviour | ( | System.Type | type | ) |

StateBehaviourを追加。

Parameters

  type | 追加するStateBehaviourの型

Returns
  追加したStateBehaviour

T AddBehaviour< T > | ( |  | ) |

StateBehaviourを追加。

Template Parameters

  T | 追加するStateBehaviourの型

Returns
  追加したStateBehaviour

Type Constraints

  T | : | StateBehaviour |

bool Contains | ( | StateBehaviour | behaviour | ) |

StateBehaviourが含まれているかどうか。

Parameters

  behaviour | 判定するStateBehaviour。

Returns
  含まれているかどうか。

void DestroyBehaviour | ( | Object | behaviourObj | ) |

StateBehaviourを破棄する。

Parameters

  behaviourObj | 破棄したいStateBehaviour.

void DestroyBehaviours | ( |  | ) |

内部処理用。

void DisconnectState | ( | int | stateID | ) |

内部処理用。

StateBehaviour GetBehaviour | ( | System.Type | type | ) |

StateBehaviourを取得。

Parameters

  type | 取得したいStateBehaviourの型。

Returns
  見つかったStateBehaviour。ない場合はnull。

T GetBehaviour< T > | ( |  | ) |

StateBehaviourを取得。

Template Parameters

  T | 取得したいStateBehaviourの型。

Returns
  見つかったStateBehaviour。ない場合はnull。

Type Constraints

  T | : | StateBehaviour |

StateBehaviour GetBehaviourFromIndex | ( | int | index | ) |

StateBehaviourをindexから取得。

Parameters

  index | インデックス

Returns
  StateBehaviour

Object GetBehaviourObjectFromIndex | ( | int | index | ) |

StateBehaviourのObjectをindexから取得。

Parameters

  index | インデックス

Returns
  Object

StateBehaviour [] GetBehaviours | ( | System.Type | type | ) |

StateBehaviourを取得。

Parameters

  type | 取得したいStateBehaviourの型。

Returns
  見つかったStateBehaviourの配列。

T [] GetBehaviours< T > | ( |  | ) |

StateBehaviourを取得。

Template Parameters

  T | 取得したいStateBehaviourの型。

Returns
  見つかったStateBehaviourの配列。

Type Constraints

  T | : | StateBehaviour |

override string GetName | ( |  | ) |
| virtual

ノードの名前を取得

Returns
  ノードの名前

Reimplemented from Node.

int IndexOfBehaviour | ( | Object | behaviourObj | ) |

StateBehaviourのインデックスを返す。

Parameters

  behaviourObj | 検索するStateBehaviour

Returns
  見つかった場合はインデックス、ない場合は-1を返す。

void InsertBehaviour | ( | int | index,
|  | StateBehaviour | behaviour
| ) |  |

StateBehaviourを挿入。

Parameters

  index | 挿入先インデックス
  behaviour | 挿入するStateBehaviour

StateBehaviour InsertBehaviour | ( | int | index,
|  | System.Type | type
| ) |  |

StateBehaviourを挿入。

Parameters

  index | 挿入先インデックス
  type | 追加するStateBehaviourの型

Returns
  挿入したStateBehaviour

T InsertBehaviour< T > | ( | int | index | ) |

StateBehaviourを追加。

Template Parameters

  T | 挿入するStateBehaviourの型

Parameters

  index | 挿入先インデックス

Returns
  挿入したStateBehaviour

Type Constraints

  T | : | StateBehaviour |

override bool IsContainsBehaviour | ( | NodeBehaviour | behaviour | ) |
| virtual

NodeBehaviourを含んでいるかをチェックする。

Parameters

  behaviour | チェックするNodeBehaviour

Returns
  NodeBehaviourを含んでいる場合にtrueを返す。

Reimplemented from Node.

void LateUpdateBehaviours | ( |  | ) |

内部処理用。

void MoveBehaviour | ( | int | fromIndex,
|  | State | toState,
|  | int | toIndex
| ) |  |

StateBehaviourの順番を移動する。

Parameters

  fromIndex | 移動させたいインデックス。
  toState | 移動先のState。
  toIndex | 移動先のインデックス。

override void OnGraphChanged | ( |  | ) |
| protected virtual

Nodeが所属するNodeGraphが変わった際に呼ばれる。

Reimplemented from Node.

void RemoveBehaviour | ( | Object | behaviourObj | ) |

StateBehaviourを削除する。インスタンスは削除されないため、StateBehaviour.Destroyを使用すること。

Parameters

  behaviourObj | 削除するStateBehaviour。

void SendTrigger | ( | string | message | ) |

トリガーメッセージを送信する。StateBehaviour.OnStateTriggerが呼び出される。

Parameters

  message |

void SetBehaviour | ( | int | index,
|  | StateBehaviour | behaviour
| ) |  |

StateBehaviourを設定する。

Parameters

  index | インデックス
  behaviour | StateBehaviour

元のStateBehaviourは破棄しないため注意。 StateBehaviourを追加したい場合はAddBehaviourを使用して下さい。 また、破棄したい場合はDestroyBehaviourを使用して下さい。

void SwapBehaviour | ( | int | fromIndex,
|  | int | toIndex
| ) |  |

StateBehaviourの順番を入れ替える。

Parameters

  fromIndex | 入れ替えたいインデックス。
  toIndex | 入れ替え先インデックス。

void UpdateBehaviours | ( |  | ) |

内部処理用。

## Member Data Documentation

string name = "New State"

ステートの名前。

## Property Documentation

int behaviourCount
| get

Behaviourの数を取得。

StateBehaviour [] behaviours
| get

非推奨。behaviourCountとGetBehaviourFromIndexを使用して下さい。

bool breakPoint
| get set

Break point.

When this property is true, the editor is in a pause state at the timing of entering the state.

bool resident
| get

常駐するStateかどうかを取得。

int stateID
| get

ステートIDを取得。

ArborFSMInternal stateMachine
| get

FSMを取得。

uint transitionCount
| get set

遷移回数。